;;;; coerce.scm
;;;; Kon Lovett, Sep '06

;;;

(cond-expand
  [hygienic-macros
    (define-syntax (case-coerce X)
      (syntax-case X (else)
        [(sk [(?sym0 ...) ?form0 ...] ... [else ?else0 ...])
          (with-syntax ([objvar (datum->syntax-object #'sk 'object)]
                        [errvar (datum->syntax-object #'sk 'on-error)])
            #'(make-case-coerce
                (lambda (objvar typ errvar)
                  (case typ [(?sym0 ...) ?form0 ...] ... [else ?else0 ...]))) ) ]
        [(sk [(?sym0 ...) ?form0 ...] ...)
          (with-syntax ([objvar (datum->syntax-object #'sk 'object)]
                        [errvar (datum->syntax-object #'sk 'on-error)])
            #'(make-case-coerce
                (lambda (objvar typ errvar)
                  (case typ [(?sym0 ...) ?form0 ...] ... [else (errvar)]))) ) ] ) ) ]
  [else
    (define-macro (case-coerce . ?cases)
      (let ([?typvar (gensym)]
            [has-else
              (let loop ([cases ?cases])
                (and (not (null? cases))
                     (or (eq? 'else (car cases))
                         (loop (cdr cases)))))])
        `(make-case-coerce
           (lambda (object ,?typvar on-error)
             (case ,?typvar ,@?cases ,@(if has-else '() '([else (on-error)]))))) ) ) ] )
